var writeCard, ctx;
var lineColor = "black";
var lastLineWidth = -1;
var lastTime = 0; //用于计算时间
var isMouseDown = false;
var lastLoc = {
    x: 0,
    y: 0
}; //起笔坐标 
var maxLineWidth = 10;
var minLineWidth = 1;
var maxStrokeV = 10;
var minStrokeV = 0.1;
var isEmpty = true; // 是否是空的  为true的条件是： 1.打开看了一下，直接关了。2. 点击了清空按钮
let imgBase64FromMobile; // 移动端写在localStorage里面的base64图片
let base64FromPC; // pc端写在span标签里的base64图片
window.genWriteCard = function () {
    base64FromPC = document.querySelector('#base64-write-card').innerHTML;
    let containerFlag = document.querySelector('#write-card-container');
    if (containerFlag) {
        showCanvas();
        return;
    }
    let container = document.createElement('div');
    container.id = 'write-card-container';
    let children = `
    <div id="writeCard-controller">
    <div class="writeCard-controller-wrapper">
        <div class="writeCard-colorList" title="颜色">
            <button class="cur-color color_btn" cur-id="black_btn" itemColor="black" ></button>
            <div class="color-list-btn-container">
                <button id="black_btn" class="color_btn color_btn_selected" itemColor="black"></button>
                <button id="blue_btn" class="color_btn" itemColor="blue"></button>
                <button id="green_btn" class="color_btn" itemColor="green"></button>
                <button id="red_btn" class="color_btn" itemColor="red"></button>
                <button id="orange_btn" class="color_btn" itemColor="orange"></button>
                <button id="yellow_btn" class="color_btn" itemColor="yellow"></button>
            </div>
        </div>
        <div class="lineWidthList" title="粗细">
            <div class="thickness-container">
                <div class="circle circle-out"><div class="dot"></div></div>
                <div class="lineWidthList-opt">
                    <div class="circle"><div class="dot"></div></div>
                    <input type='range' id="thickness" />
                </div>
            </div>
        </div>
        <br>
        <div class="option" id="rewrite_writeCard" title="清除"><image src="./images/u620.png"/></div>
        <div class="option" id="finish_writeCard" title="完成">√</div>
        <div class="option" id="close_writeCard" title="关闭"><image src="./images/clear_u603.svg" /></div></div>
    </div><div class="boxs-container"><div class="one-and-two"><div class="boxs one"></div><div class="boxs two"></div></div><div class="three-and-four"><div class="boxs three"></div><div class="boxs four"></div></div></div>
    <canvas id="writeCard"></canvas>
    `
    container.innerHTML = (children);
    let body = document.querySelector('body');
    body.appendChild(container);
    initCanvas();
    imgBase64FromMobile = localStorage.getItem('imgData');
    imgBase64FromMobile ? renderImgBase64(imgBase64FromMobile) : (base64FromPC ? renderImgBase64(base64FromPC) : '')
    // drawGrid(ctx);
    bindEventForCanvas();
    bindEventForDOM();
}

function renderImgBase64(imgBase64) {
    isEmpty = false;
    // 内存中先加载，然后当内存加载完毕时，再把内存中的数据填充到我们的 dom元素中，这样能够快速的去
    // 反应，比如网易的图片
    var canvasWidth = $(window).width() - 50 - 30 - 200;
    let clientHeight = document.body.clientHeight;
    if (clientHeight <= canvasWidth) {
        canvasWidth = clientHeight
    }
    // var canvasWidth = Math.min(500, $(window).width() - 200);
    var img = new Image();
    img.onload = function () {
        console.log(imgBase64);
        console.log(canvasWidth);
        // 将图片画到canvas上面上去！
        ctx.drawImage(img, 0, 0, canvasWidth, canvasWidth);
    }
    img.src = imgBase64;
}

function showCanvas() {
    let container = document.querySelector('#write-card-container');
    container.style.display = 'block';
}

function initCanvas() {
    writeCard = document.getElementById('writeCard');
    let clientHeight = document.body.clientHeight;
    var canvasWidth = $(window).width() - 50 - 30 - 200;
    if (clientHeight <= canvasWidth) {
        canvasWidth = clientHeight
    }
    console.log(canvasWidth);
    let boxWidth = (canvasWidth / 2) + 4 + 'px';
    let boxs = document.getElementsByClassName('boxs');
    for (let i = 0; i < boxs.length; i++) {
        const cell = boxs[i];
        cell.style.width = boxWidth;
        cell.style.height = boxWidth;
    }
    ctx = writeCard.getContext("2d");
    ctx.globalAlpha = 0;
    writeCard.width = canvasWidth;
    writeCard.height = writeCard.width;
    // $("#writeCard-controller").css("width", canvasWidth + "px")
}

function beginStroke(point) {
    isMouseDown = true;
    lastLoc = windowToCanvas(point.x, point.y);
    lastTime = new Date().getTime();
}

function endStroke() {
    isMouseDown = false;
}

function moveStroke(point) {
    var curLoc = windowToCanvas(point.x, point.y);
    var curTime = new Date().getTime();
    var s = calcDistance(curLoc, lastLoc); //获取笔锋经过的距离
    var t = curTime - lastTime; //获取笔锋经过的时间 ，用于计算行笔速度，赋值不同的宽度
    var lineWidth = calcLineWidth(t, s);
    ctx.beginPath();
    ctx.moveTo(lastLoc.x, lastLoc.y);
    ctx.lineTo(curLoc.x, curLoc.y);
    ctx.strokeStyle = lineColor;
    ctx.lineWidth = lineWidth;
    ctx.lineCap = "round";
    ctx.lineJoin = "round";
    ctx.stroke();
    ctx.closePath();
    lastLoc = curLoc;
    lastTime = curTime;
    lastLineWidth = lineWidth;
}

function bindEventForCanvas() {
    writeCard.onmousedown = function (e) {
        e.preventDefault();
        beginStroke({
            x: e.clientX,
            y: e.clientY
        });
    }
    writeCard.onmouseup = function (e) {
        endStroke();
        e.preventDefault();
    }
    writeCard.onmouseout = function (e) {
        endStroke();
        e.preventDefault();
    }
    writeCard.onmousemove = function (e) {
        isEmpty = false;
        e.preventDefault();
        if (isMouseDown) {
            moveStroke({
                x: e.clientX,
                y: e.clientY
            });
        }
    }
    // 触屏事件
    writeCard.addEventListener("touchstart", function (e) {
        e.preventDefault();
        var touch = e.touches[0];
        beginStroke({
            x: touch.pageX,
            y: touch.pageY
        });
    })
    writeCard.addEventListener("touchmove", function (e) {
        isEmpty = false;
        e.preventDefault();
        if (isMouseDown) {
            var touch = e.touches[0];
            moveStroke({
                x: touch.pageX,
                y: touch.pageY
            });
        }
    })
    writeCard.addEventListener("touchend", function (e) {
        e.preventDefault();
        endStroke();
    })
}

function calcLineWidth(t, s) {
    // 计算运笔速度和时间，获取不同得到宽度
    var resultLineWidth = 0;
    var v = s / t;
    if (v <= minStrokeV) {
        resultLineWidth = maxLineWidth;
    } else if (v >= maxStrokeV) {
        resultLineWidth = minLineWidth;
    } else {
        resultLineWidth = maxLineWidth - ((v - minStrokeV) / (maxStrokeV - minStrokeV)) * (maxLineWidth - minLineWidth);
    }
    if (lastLineWidth = -1) {
        return resultLineWidth;
    }
    return lastLineWidth * 2 / 3 + resultLineWidth * 1 / 3;
};

function calcDistance(loc1, loc2) {
    return Math.sqrt((loc1.x - loc2.x) * (loc1.x - loc2.x) + (loc1.y - loc2.y) * (loc1.y - loc2.y))
};

function windowToCanvas(x, y) {
    var box = writeCard.getBoundingClientRect();
    return {
        x: x - box.left,
        y: y - box.top
    };
};

function bindEventForDOM() {
    // 清空画笔
    $("#rewrite_writeCard").click(function (e) {
        isEmpty = true;
        clearCanvas();
    })

    // 画笔粗细点击
    $('.circle-out').click(function (e) {
        if ($('.lineWidthList-opt').css('display') == 'flex') {
            $('.lineWidthList-opt').hide();
        } else {
            $('.lineWidthList-opt').css('display', 'flex');
        }
    })

    // 完成按钮
    $("#finish_writeCard").click(function (e) {
        let writeCard = document.querySelector('#writeCard');
        let imgData = writeCard.toDataURL("image/png");
        if (isEmpty) {
            try {
                Cef.getBase64('');
            } catch (error) {
                localStorage.setItem('imgData', imgData)
                prompt('', 'saveWrittenWords')
            }
        } else {
            try {
                Cef.getBase64(imgData);
            } catch (error) {
                localStorage.setItem('imgData', imgData)
                prompt("", 'saveWrittenWords')
            }
        }
    })

    // 关闭按钮
    $("#close_writeCard").click(function (e) { // 用户没操作，点关闭  【pc端 传个空】 、 【手机端 传打开时候的值，如果是空，那就传个透明的空白图】
        // clearCanvas();
        let writeCard = document.querySelector('#writeCard');
        let imgData = writeCard.toDataURL("image/png");
        if (isEmpty) { 
            try {
                Cef.closeWriteCard();
            } catch (error) {
                localStorage.setItem('imgData', imgBase64FromMobile)
                prompt('', 'saveWrittenWords')
            }
        } else {
            try {
                Cef.closeWriteCard();
            } catch (error) {
                localStorage.setItem('imgData', imgBase64FromMobile);
                prompt(imgData, 'saveWrittenWords');
            }
        }
    })

    // 画笔粗细
    $('#thickness').val(33)
    $('#thickness').change(function (e) {
        let res = ($(this).val() / 100).toFixed(2);
        console.log(res);
        maxLineWidth = res * 30
    })

    // 画笔颜色
    $(".color_btn").click(function () {
        if (!$(this).hasClass("color_btn_selected")) {
            $(this).addClass("color_btn_selected").siblings().removeClass("color_btn_selected");
        }
        lineColor = $(this).attr("itemColor");
        $('.cur-color').css('background-color', $(this).attr("itemColor"));
        // $('.color-list-btn-container').hide();
        if ($(this).attr('cur-id') == "black_btn") {
            let flag = $('.color-list-btn-container').css('display') == 'flex';
            flag ? $('.color-list-btn-container').hide() : $('.color-list-btn-container').css('display', 'flex');
        }
    })

}

function clearCanvas() {
    ctx.clearRect(0, 0, writeCard.width, writeCard.height);
}


/**
window.destoryWriteCard = function () {
    let container = document.querySelector('#write-card-container');
    if (container) {
        container.style.display = 'none';
        clearCanvas();
    }
}
*/

/**
// 画笔粗细
$(".width_btn").click(function () {
    if (!$(this).hasClass("width_btn_selected")) {
        $(this).addClass("width_btn_selected").siblings().removeClass("width_btn_selected");
    }
    maxLineWidth = $(this).attr("lineWidth");
})
*/


/**
    function drawGrid() {
        console.log(ctx);
        ctx.save();
        ctx.beginPath();
        ctx.moveTo(3, 3);
        ctx.lineTo(writeCard.width - 3, 3);
        ctx.lineTo(writeCard.width - 3, writeCard.height - 3);
        ctx.lineTo(3, writeCard.height - 3);
        ctx.lineTo(3, 3);
        ctx.lineWidth = 6;
        ctx.strokeStyle = "red";
        ctx.closePath();
        ctx.stroke();
        ctx.restore();
        ctx.save();
        ctx.beginPath();
        ctx.setLineDash([8, 8]);
        ctx.moveTo(3, 3);
        ctx.lineTo(3, writeCard.height);
        ctx.moveTo(writeCard.width / 2, 3);
        ctx.lineTo(writeCard.width / 2, writeCard.height);
        ctx.moveTo(3, writeCard.height / 2);
        ctx.lineTo(writeCard.width, writeCard.height / 2);
        ctx.strokeStyle = "red";
        ctx.lineWidth = 1;
        ctx.stroke();
        ctx.closePath();
        ctx.restore();
    }
*/